/*
**	$Id: MacroPanel.c,v 1.4 92/04/21 16:59:03 olsen Sta Locker: olsen $
**	$Revision: 1.4 $
**	$Date: 92/04/21 16:59:03 $
**
**	Editing panel for key macro configuration
**
**	Copyright  1990-1992 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_F1,GAD_F2,GAD_F3,GAD_F4,GAD_F5,GAD_F6,GAD_F7,GAD_F8,GAD_F9,
		GAD_F10,GAD_QUALIFIER,GAD_USE,GAD_LOAD,GAD_SAVE,GAD_CANCEL };

#define WIDTH	535
#define HEIGHT	193

	/* Some layout assistance. */

#define GADGET_WIDTH	88
#define GADGET_COUNT	4
#define GADGET_SPACE	(GADGET_WIDTH + ((WIDTH - 20) - (GADGET_COUNT * GADGET_WIDTH)) / (GADGET_COUNT - 1))

STATIC STRPTR ModifierString[5] =
{
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

STATIC struct Gadget *
CreateAllGadgets(struct Gadget **GadgetArray,struct Gadget **GadgetList,APTR VisualInfo,UWORD TopEdge)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0;

	LocalizeString(ModifierString,MSG_MACROPANEL_NONE_TXT,MSG_MACROPANEL_CONTROL_TXT);

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		NewGadget . ng_Width		= 484;
		NewGadget . ng_Height		= 14;
		NewGadget . ng_GadgetText	= "F 1";
		NewGadget . ng_TextAttr		= &DefaultFont;
		NewGadget . ng_VisualInfo	= VisualInfo;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= (strlen(NewGadget . ng_GadgetText) + 2) * 8 + 1;
		NewGadget . ng_TopEdge		= 1 + TopEdge;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GTST_MaxChars,	255,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 2";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GTST_MaxChars,	255,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 3";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GTST_MaxChars,	255,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 4";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GTST_MaxChars,	255,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 5";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GTST_MaxChars,	255,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 6";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GTST_MaxChars,	255,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 7";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GTST_MaxChars,	255,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 8";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GTST_MaxChars,	255,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F 9";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GTST_MaxChars,	255,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= "F10";
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(STRING_KIND,Gadget,&NewGadget,
			GTST_MaxChars,	255,
			GTST_EditHook,	&CommandHook,
			GA_Immediate,	TRUE,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_MACROPANEL_KEY_MODIFIER_GAD);
		NewGadget . ng_Width		= 140;
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= (WIDTH - NewGadget . ng_Width) >> 1;
		NewGadget . ng_TopEdge		= NewGadget . ng_TopEdge + NewGadget . ng_Height + 1;

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
			GTCY_Labels,	ModifierString,
			GTCY_Active,	0,
		TAG_DONE);

		NewGadget . ng_Width		= 88;	/* NEW 52 */
		NewGadget . ng_Height		= 12;
		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_USE_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_Flags		= 0;
		NewGadget . ng_LeftEdge		= 10;
		NewGadget . ng_TopEdge		= HEIGHT - 3 - NewGadget . ng_Height;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_LOAD_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= NewGadget . ng_LeftEdge + GADGET_SPACE;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_SAVE_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= NewGadget . ng_LeftEdge + GADGET_SPACE;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_CANCEL_GAD);
		NewGadget . ng_GadgetID		= Counter;
		NewGadget . ng_LeftEdge		= NewGadget . ng_LeftEdge + GADGET_SPACE;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			GT_Underscore,	'_',
		TAG_DONE);
	}

	return(Gadget);
}

VOID
MacroPanel(struct MacroKeys *MacroKeys)
{
	struct Window		*PanelWindow;
	struct Gadget		*GadgetList = NULL;
	struct Gadget		*GadgetArray[GAD_CANCEL + 1];
	LONG			 i;

	struct MacroKeys	*Keys;

	if(Keys = (struct MacroKeys *)AllocVec(sizeof(struct MacroKeys),MEMF_ANY|MEMF_CLEAR))
	{
		CopyMem(MacroKeys,Keys,sizeof(struct MacroKeys));

		if(CreateAllGadgets(&GadgetArray[0],&GadgetList,VisualInfo,Screen -> WBorTop + Screen -> Font -> ta_YSize + 1))
		{
			if(PanelWindow = OpenWindowTags(NULL,
				WA_Left,	(Screen -> Width - WIDTH) >> 1,
				WA_Top,		(Screen -> Height - HEIGHT) >> 1,
				WA_Width,	WIDTH,
				WA_Height,	HEIGHT,

				WA_Activate,	TRUE,
				WA_DragBar,	TRUE,
				WA_DepthGadget,	TRUE,
				WA_CloseGadget,	TRUE,
				WA_RMBTrap,	TRUE,
				WA_DepthGadget,	TRUE,
				WA_CustomScreen,Screen,

				WA_IDCMP,	IDCMP_GADGETDOWN | IDCMP_CLOSEWINDOW | IDCMP_VANILLAKEY | IDCMP_ACTIVEWINDOW | BUTTONIDCMP | CYCLEIDCMP | STRINGIDCMP,

				WA_Title,	LocaleString(MSG_MACROPANEL_MACRO_PREFERENCES_TXT),
			TAG_DONE))
			{
				struct IntuiMessage	*Massage;
				ULONG			 Class,Code;
				struct Gadget		*Gadget;
				BYTE			 Terminated = FALSE;

				UBYTE			 DummyBuffer[256],*DummyChar;

				struct FileRequest	*FileRequest;

				LONG			 Modifier = 0;

				PushWindow(PanelWindow);

				AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
				RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
				GT_RefreshWindow(PanelWindow,NULL);

				if(XEmulatorBase && Config . Emulation == EMULATION_EXTERNAL)
				{
					ULONG KeyMask = XEmulatorGetFreeMacroKeys(XEM_IO,Modifier);

					for(i = 0 ; i < 10 ; i++)
					{
						GT_SetGadgetAttrs(GadgetArray[GAD_F1 + i],PanelWindow,NULL,
							GTST_String,	Keys -> Keys[Modifier][i],
							GA_Disabled,	!(KeyMask & (1 << i)),
						TAG_DONE);
					}
				}
				else
				{
					for(i = 0 ; i < 10 ; i++)
					{
						GT_SetGadgetAttrs(GadgetArray[GAD_F1 + i],PanelWindow,NULL,
							GTST_String,Keys -> Keys[Modifier][i],
						TAG_DONE);
					}
				}

				ActiveGadget = NULL;

				while(!Terminated)
				{
					WaitPort(PanelWindow -> UserPort);

					while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
					{
						Class	= Massage -> Class;
						Code	= Massage -> Code;
						Gadget	= (struct Gadget *)Massage -> IAddress;

						GT_ReplyIMsg(Massage);

						if(Class == IDCMP_ACTIVEWINDOW && ActiveGadget)
							ActivateGadget(ActiveGadget,PanelWindow,NULL);

						if(Class == IDCMP_VANILLAKEY)
							KeySelect(GadgetArray,GAD_CANCEL,Code,PanelWindow,&Gadget,&Class,&Code);

						if(Class == IDCMP_GADGETDOWN)
						{
							if((Gadget -> GadgetType & GTYP_GTYPEMASK) == GTYP_STRGADGET)
								ActiveGadget = Gadget;
						}

						if(Class == IDCMP_CLOSEWINDOW)
							Terminated = TRUE;

GadCheck:					if(Class == IDCMP_GADGETUP)
						{
							switch(Gadget -> GadgetID)
							{
								case GAD_QUALIFIER:	for(i = 0 ; i < 10 ; i++)
												strcpy(Keys -> Keys[Modifier][i],GT_STRING(GadgetArray[i]));

											Modifier = Code;

											if(XEmulatorBase && Config . Emulation == EMULATION_EXTERNAL)
											{
												ULONG KeyMask = XEmulatorGetFreeMacroKeys(XEM_IO,Modifier);

												ActiveGadget = NULL;

												for(i = 0 ; i < 10 ; i++)
												{
													GT_SetGadgetAttrs(GadgetArray[GAD_F1 + i],PanelWindow,NULL,
														GTST_String,	Keys -> Keys[Modifier][i],
														GA_Disabled,	!(KeyMask & (1 << i)),
													TAG_DONE);

													if((KeyMask & (1 << i)) && !ActiveGadget)
														ActiveGadget = GadgetArray[GAD_F1 + i];
												}

												if(ActiveGadget)
													ActivateGadget(ActiveGadget,PanelWindow,NULL);
											}
											else
											{
												for(i = 0 ; i < 10 ; i++)
												{
													GT_SetGadgetAttrs(GadgetArray[GAD_F1 + i],PanelWindow,NULL,
														GTST_String,Keys -> Keys[Modifier][i],
													TAG_DONE);
												}
											}

											break;

								case GAD_USE:		Terminated = TRUE;

											for(i = 0 ; i < 10 ; i++)
												strcpy(Keys -> Keys[Modifier][i],GT_STRING(GadgetArray[i]));

											CopyMem(Keys,MacroKeys,sizeof(struct MacroKeys));

											break;

								case GAD_LOAD:		strcpy(DummyBuffer,LastMacros);

											DummyChar = PathPart(DummyBuffer);

											*DummyChar = 0;

											BlockWindow(PanelWindow);

											if(FileRequest = GetFile(LocaleString(MSG_MACROPANEL_LOAD_MACRO_KEYS_TXT),DummyBuffer,FilePart(LastMacros),DummyBuffer,"term#?",FALSE,FALSE,FALSE,LocaleString(MSG_GLOBAL_LOAD_TXT)))
											{
												if(!LoadMacros(DummyBuffer,Keys))
													MyEasyRequest(Window,LocaleString(MSG_MACROPANEL_COULD_NOT_LOAD_MACRO_KEYS_TXT),LocaleString(MSG_GLOBAL_CONTINUE_TXT),DummyBuffer);
												else
												{
													strcpy(Config . MacroFile,DummyBuffer);

													strcpy(LastMacros,DummyBuffer);

													for(i = 0 ; i < 10 ; i++)
													{
														GT_SetGadgetAttrs(GadgetArray[GAD_F1 + i],PanelWindow,NULL,
															GTST_String,Keys -> Keys[Modifier][i],
														TAG_DONE);
													}
												}
											}

											ReleaseWindow(PanelWindow);

											break;

								case GAD_SAVE:		strcpy(DummyBuffer,LastMacros);

											DummyChar = PathPart(DummyBuffer);

											*DummyChar = 0;

											BlockWindow(PanelWindow);

											for(i = 0 ; i < 10 ; i++)
												strcpy(Keys -> Keys[Modifier][i],GT_STRING(GadgetArray[i]));

											if(FileRequest = GetFile(LocaleString(MSG_MACROPANEL_SAVE_MACRO_KEYS_TXT),DummyBuffer,FilePart(LastMacros),DummyBuffer,"term#?",TRUE,FALSE,FALSE,LocaleString(MSG_GLOBAL_SAVE_TXT)))
											{
												if(!WriteIFFData(DummyBuffer,Keys,sizeof(struct MacroKeys),'KEYS'))
													MyEasyRequest(Window,LocaleString(MSG_MACROPANEL_COULD_NOT_SAVE_MACRO_KEYS_TXT),LocaleString(MSG_GLOBAL_CONTINUE_TXT),DummyBuffer);
												else
													strcpy(LastMacros,DummyBuffer);
											}

											ReleaseWindow(PanelWindow);

											break;

								case GAD_CANCEL:	Terminated = TRUE;

											CopyMem(Keys,MacroKeys,sizeof(struct MacroKeys));

											break;

								default:		break;
							}
						}
					}
				}

				RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

				PopWindow();

				CloseWindow(PanelWindow);
			}
		}

		FreeGadgets(GadgetList);

		FreeVec(Keys);
	}
}
